VTK: vtkPlotLine3D Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
vtkPlotLine3D Class Reference

Class for drawing an XYZ line plot given three columns from a vtkTable. More...

`#include <vtkPlotLine3D.h>`

Inheritance diagram for vtkPlotLine3D:
[legend]
Collaboration diagram for vtkPlotLine3D:
[legend]

## Public Types
typedef vtkPlotPoints3D | Superclass
Public Types inherited from vtkPlotPoints3D
typedef vtkPlot3D | Superclass
Public Types inherited from vtkPlot3D
typedef vtkContextItem | Superclass
Public Types inherited from vtkContextItem
typedef vtkAbstractContextItem | Superclass
Public Types inherited from vtkAbstractContextItem
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkPlotLine3D * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
bool | Paint (vtkContext2D *painter) override
| Paint event for the XYZ plot, called whenever the chart needs to be drawn. More...
Public Member Functions inherited from vtkPlotPoints3D
vtkPlotPoints3D * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
bool | Paint (vtkContext2D *painter) override
| Paint event for the XY plot, called whenever the chart needs to be drawn. More...
Public Member Functions inherited from vtkPlot3D
vtkPlot3D * | NewInstance () const
virtual void | SetColors (vtkDataArray *colorArr)
| Set the color of each point in the plot. More...
vtkPoints * | GetVTKPoints ()
| Get all the data points within this plot. More...
std::vector< vtkVector3f > | GetPoints ()
| Get a copy of all the data points. More...
std::string | GetXAxisLabel ()
| Get the label for the X axis. More...
std::string | GetYAxisLabel ()
| Get the label for the Y axis. More...
std::string | GetZAxisLabel ()
| Get the label for the Z axis. More...
std::vector< vtkVector3f > | GetDataBounds ()
| Get the bounding cube surrounding the currently rendered data points. More...
void | SetPen (vtkPen *pen)
| Set/get the vtkPen object that controls how this plot draws (out)lines. More...
vtkPen * | GetPen ()
| Set/get the vtkPen object that controls how this plot draws (out)lines. More...
void | SetSelectionPen (vtkPen *pen)
| Set/get the vtkPen object that controls how this plot draws (out)lines. More...
vtkPen * | GetSelectionPen ()
| Set/get the vtkPen object that controls how this plot draws (out)lines. More...
virtual void | SetInputData (vtkTable *input)
| Set the input to the plot. More...
virtual void | SetInputData (vtkTable *input, const vtkStdString &xName, const vtkStdString &yName, const vtkStdString &zName)
| Set the input to the plot. More...
virtual void | SetInputData (vtkTable *input, const vtkStdString &xName, const vtkStdString &yName, const vtkStdString &zName, const vtkStdString &colorName)
| Set the input to the plot. More...
virtual void | SetInputData (vtkTable *input, vtkIdType xColumn, vtkIdType yColumn, vtkIdType zColumn)
| Set the input to the plot. More...
virtual vtkChartXYZ * | GetChart ()
| Get/set the chart for this plot. More...
virtual void | SetChart (vtkChartXYZ *chart)
| Get/set the chart for this plot. More...
virtual void | SetSelection (vtkIdTypeArray *id)
| Set/get the selection array for the plot. More...
virtual vtkIdTypeArray * | GetSelection ()
| Set/get the selection array for the plot. More...
Public Member Functions inherited from vtkContextItem
vtkContextItem * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | SetTransform (vtkContextTransform *)
| Set the transform of the item. More...
virtual double | GetOpacity ()
| Get the opacity of the item. More...
virtual void | SetOpacity (double)
| Set the opacity of the item. More...
Public Member Functions inherited from vtkAbstractContextItem
vtkAbstractContextItem * | NewInstance () const
virtual void | Update ()
| Perform any updates to the item that may be necessary before rendering. More...
virtual bool | PaintChildren (vtkContext2D *painter)
| Paint the children of the item, should be called whenever the children need to be rendered. More...
virtual void | ReleaseGraphicsResources ()
| Release graphics resources hold by the item. More...
vtkIdType | AddItem (vtkAbstractContextItem *item)
| Add child items to this item. More...
bool | RemoveItem (vtkAbstractContextItem *item)
| Remove child item from this item. More...
bool | RemoveItem (vtkIdType index)
| Remove child item from this item. More...
vtkAbstractContextItem * | GetItem (vtkIdType index)
| Get the item at the specified index. More...
vtkIdType | GetItemIndex (vtkAbstractContextItem *item)
| Get the index of the specified item in itemIndex. More...
vtkIdType | GetNumberOfItems ()
| Get the number of child items. More...
void | ClearItems ()
| Remove all child items from this item. More...
vtkIdType | Raise (vtkIdType index)
| Raises the child to the top of the item's stack. More...
virtual vtkIdType | StackAbove (vtkIdType index, vtkIdType under)
| Raises the child above the under sibling. More...
vtkIdType | Lower (vtkIdType index)
| Lowers the child to the bottom of the item's stack. More...
virtual vtkIdType | StackUnder (vtkIdType child, vtkIdType above)
| Lowers the child under the above sibling. More...
virtual bool | Hit (const vtkContextMouseEvent &mouse)
| Return true if the supplied x, y coordinate is inside the item. More...
virtual vtkAbstractContextItem * | GetPickedItem (const vtkContextMouseEvent &mouse)
| Return the item under the mouse. More...
virtual bool | MouseEnterEvent (const vtkContextMouseEvent &mouse)
| Mouse enter event. More...
virtual bool | MouseMoveEvent (const vtkContextMouseEvent &mouse)
| Mouse move event. More...
virtual bool | MouseLeaveEvent (const vtkContextMouseEvent &mouse)
| Mouse leave event. More...
virtual bool | MouseButtonPressEvent (const vtkContextMouseEvent &mouse)
| Mouse button down event Return true if the item holds the event, false if the event can be propagated to other items. More...
virtual bool | MouseButtonReleaseEvent (const vtkContextMouseEvent &mouse)
| Mouse button release event. More...
virtual bool | MouseDoubleClickEvent (const vtkContextMouseEvent &mouse)
| Mouse button double click event. More...
virtual bool | MouseWheelEvent (const vtkContextMouseEvent &mouse, int delta)
| Mouse wheel event, positive delta indicates forward movement of the wheel. More...
virtual bool | KeyPressEvent (const vtkContextKeyEvent &key)
| Key press event. More...
virtual bool | KeyReleaseEvent (const vtkContextKeyEvent &key)
| Key release event. More...
virtual void | SetScene (vtkContextScene *scene)
| Set the vtkContextScene for the item, always set for an item in a scene. More...
vtkContextScene * | GetScene ()
| Get the vtkContextScene for the item, always set for an item in a scene. More...
virtual void | SetParent (vtkAbstractContextItem *parent)
| Set the parent item. More...
vtkAbstractContextItem * | GetParent ()
| Get the parent item. More...
virtual vtkVector2f | MapToParent (const vtkVector2f &point)
| Maps the point to the parent coordinate system. More...
virtual vtkVector2f | MapFromParent (const vtkVector2f &point)
| Maps the point from the parent coordinate system. More...
virtual vtkVector2f | MapToScene (const vtkVector2f &point)
| Maps the point to the scene coordinate system. More...
virtual vtkVector2f | MapFromScene (const vtkVector2f &point)
| Maps the point from the scene coordinate system. More...
virtual bool | GetVisible ()
| Get the visibility of the item (should it be drawn). More...
virtual void | SetVisible (bool)
| Set the visibility of the item (should it be drawn). More...
virtual bool | GetInteractive ()
| Get if the item is interactive (should respond to mouse events). More...
virtual void | SetInteractive (bool)
| Set if the item is interactive (should respond to mouse events). More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPlotLine3D * | SafeDownCast (vtkObjectBase *o)
static vtkPlotLine3D * | New ()
| Creates a 3D Chart object. More...
Static Public Member Functions inherited from vtkPlotPoints3D
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPlotPoints3D * | SafeDownCast (vtkObjectBase *o)
static vtkPlotPoints3D * | New ()
Static Public Member Functions inherited from vtkPlot3D
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPlot3D * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkContextItem
static vtkTypeBool | IsTypeOf (const char *type)
static vtkContextItem * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAbstractContextItem
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractContextItem * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkPlotLine3D ()
| ~vtkPlotLine3D () override
Protected Member Functions inherited from vtkPlotPoints3D
| vtkPlotPoints3D ()
| ~vtkPlotPoints3D () override
void | ReleaseGraphicsCache () override
| Release cache entries created by this context item. More...
Protected Member Functions inherited from vtkPlot3D
| vtkPlot3D ()
| ~vtkPlot3D () override
virtual void | ComputeDataBounds ()
| Generate a bounding cube for our data. More...
Protected Member Functions inherited from vtkContextItem
| vtkContextItem ()=default
| ~vtkContextItem () override
Protected Member Functions inherited from vtkAbstractContextItem
| vtkAbstractContextItem ()
| ~vtkAbstractContextItem () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkPlotPoints3D
vtkNew< vtkPoints > | SelectedPoints
| The selected points. More...
vtkTimeStamp | SelectedPointsBuildTime
| The selected points. More...
Protected Attributes inherited from vtkPlot3D
vtkSmartPointer< vtkPen > | Pen
| This object stores the vtkPen that controls how the plot is drawn. More...
vtkSmartPointer< vtkPen > | SelectionPen
| This object stores the vtkPen that controls how the plot is drawn. More...
vtkNew< vtkUnsignedCharArray > | Colors
| This array assigns a color to each datum in the plot. More...
int | NumberOfComponents
| Number of components in our color vectors. More...
std::string | XAxisLabel
| The label for the X Axis. More...
std::string | YAxisLabel
| The label for the Y Axis. More...
std::string | ZAxisLabel
| The label for the Z Axis. More...
vtkNew< vtkPoints > | Points
| The data points read in during SetInputData(). More...
vtkTimeStamp | PointsBuildTime
| When the points were last built. More...
vtkChartXYZ * | Chart
| The chart containing this plot. More...
std::vector< vtkVector3f > | DataBounds
| A bounding cube surrounding the currently rendered data points. More...
vtkSmartPointer< vtkIdTypeArray > | Selection
| Selected indices for the table the plot is rendering. More...
Protected Attributes inherited from vtkContextItem
double | Opacity = 1.0
vtkContextTransform * | Transform = nullptr
Protected Attributes inherited from vtkAbstractContextItem
vtkContextScene * | Scene
| Point to the scene the item is on - can be null. More...
vtkAbstractContextItem * | Parent
| Point to the parent item - can be null. More...
vtkContextScenePrivate * | Children
| This structure provides a list of children, along with convenience functions to paint the children etc. More...
bool | Visible
| Store the visibility of the item (default is true). More...
bool | Interactive
| Store whether the item should respond to interactions (default is true). More...
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

Class for drawing an XYZ line plot given three columns from a vtkTable.

This class draws points with a line between them given three column from a vtkTable in a vtkChartXYZ.

See also
  vtkPlotPoints3D vtkPlotLine

Online Examples:

Tests:
  vtkPlotLine3D (Tests)

Definition at line 38 of file vtkPlotLine3D.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkPlotPoints3D vtkPlotLine3D::Superclass

Definition at line 41 of file vtkPlotLine3D.h.

## Constructor & Destructor Documentation

## ◆ vtkPlotLine3D()

vtkPlotLine3D::vtkPlotLine3D | ( |  | ) |
| protected

## ◆ ~vtkPlotLine3D()

vtkPlotLine3D::~vtkPlotLine3D | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkPlotLine3D::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkPlotLine3D::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkPlotPoints3D.

## ◆ SafeDownCast()

static vtkPlotLine3D* vtkPlotLine3D::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkPlotLine3D::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkPlotPoints3D.

## ◆ NewInstance()

vtkPlotLine3D* vtkPlotLine3D::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkPlotLine3D::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkPlot3D.

## ◆ New()

static vtkPlotLine3D* vtkPlotLine3D::New | ( |  | ) |
| static

Creates a 3D Chart object.

## ◆ Paint()

bool vtkPlotLine3D::Paint | ( | vtkContext2D * | painter | ) |
| overridevirtual

Paint event for the XYZ plot, called whenever the chart needs to be drawn.

Reimplemented from vtkAbstractContextItem.

The documentation for this class was generated from the following file:

- Charts/Core/vtkPlotLine3D.h